/*
 *  SAD / Haigha / main.c -- common datatypes, variables, and macros
 *  Copyright (C) 2001-2004  SAD Development Team (see ../README)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef MAIN_H
#define MAIN_H

typedef unsigned int ui;

#define  addlist(i, l)      (i = malloc(sizeof(*l)), i->next = l, l = i)
#define  forlist(i, l)      for(i = l; i; i = i->next)
#define  dellist(i, l)      for(; ((i = l)); l = i->next, free(i))

typedef struct _slist symlist;
struct _slist { char * str; int kind, arity; symlist * next; };
extern symlist * prds, * funs;

#define  VS  1
#define  FS  2
#define  PS  3

extern ui sym_put(char * str, int kind, int arity);
#define sym_lst(n)      ((symlist *) n)
#define sym_get(n)      (sym_lst(n)->str)

typedef struct _term Term;
struct _term { ui name, vr; Term * br, * ch; };

#define ARG1(t)         ((t)->ch)
#define ARG2(t)         ((t)->ch->br)

extern Term * term_set(ui nm, ui vr);
extern Term * term_dup(Term * t);
extern void term_del(Term * t);
extern void term_out(Term * t);

typedef struct _formula Formula;
struct _formula { Term * fterm; char * mark; Formula * next; };

extern void spass_call(int argc, char ** argv, Formula * fl, ui time);
#endif
